unit Main;

interface

uses
  Windows, Forms, Buttons, ShellAPI, StdCtrls, Classes, SysUtils, ExtCtrls, Controls;

type
  TFrmMain = class(TForm)
    CountButton: TButton;
    Label1: TLabel;
    DirEdit: TEdit;
    Label2: TLabel;
    Panel: TPanel;
    RadioGroup: TRadioGroup;
    procedure CountButtonClick(Sender: TObject);
    procedure FindandCount(FileExt: String);
    procedure DirEditChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Label2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    LineCounter : Integer;
  end;

var
  FrmMain: TFrmMain;

implementation

{$R *.DFM}

procedure TFrmMain.CountButtonClick(Sender: TObject);
begin
  LineCounter := 0;
  case RadioGroup.ItemIndex of
    0: begin FindandCount('\*.pas'); FindandCount('\*.dpr'); end;
    1: FindandCount('\*.*');
  end;
  if LineCounter > 0 then
    Panel.Caption := (IntToStr(LineCounter) + ' lines of code counted.')
      else Panel.Caption := 'No code found.';
  CountButton.Enabled := False;
end;

procedure TFrmMain.FindandCount(FileExt: String);
var
  FileCounter : Integer;
  DirInfo : TSearchRec;
  SL : TStringList;
begin
  FileCounter := FindFirst((DirEdit.Text) + (FileExt), FaAnyfile, DirInfo);
  while FileCounter = 0 do
  begin
    if ((DirInfo.Attr and FaDirectory <> FaDirectory) and (DirInfo.Attr and FaVolumeId <> FaVolumeID)) then
    begin
      SL := TStringList.Create;
      SL.LoadFromFile(DirEdit.Text + '\' + DirInfo.Name);
      LineCounter := LineCounter + SL.Count;
      SL.Free;
    end;
    FileCounter := FindNext(DirInfo);
  end;
end;

procedure TFrmMain.DirEditChange(Sender: TObject);
begin
  if DirEdit.Text = '' then
    CountButton.Enabled := False else CountButton.Enabled := True;
end;

procedure TFrmMain.FormCreate(Sender: TObject);
begin
  DirEdit.Text := ExtractFilePath(Application.ExeName) + 'Source';
end;

procedure TFrmMain.Label2Click(Sender: TObject);
begin
  ShellExecute(Handle, nil, ('mailto:tan@hospitable.org'), nil, nil, SW_SHOWNORMAL);
end;

end.
